Subject: Routing questions about IPv4 header

From: Andrade Software Andrade Networking <[email-masked]>
Date: Sat, 14 Feb 1998 22:32:33 -0800 (PST)

Andrade Software & Networking
[email-masked]
X-Mailer: ELM [version 2.4 PL25]
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 7bit
Content-Length: 2111      

Pardon me if I've reached the wrong discussion groups.
These seemed to be the best ones for answering my 
questions.

My questions are about the behavior of routers
as IPv4 datagrams flow through them. These 
are based on my understanding of RFC 791.

I need to understand some subtle issues with the 
handling of the IPv4 header.  In particular I 
want to know if any of the following will break the 
proper routing behavior or cause IPv4 packets to be 
discarded with typical routers now deployed on the 
Internet.

Q1: In byte #7 there are three bits reserved.  The 
    highest bit is always set to 0.  Can it be set 
    to 1?

Q2: Again in byte #7, if the DF bit is 1 is the MF bit
    ignored?  Can it be set to 1?

Q3: If the DF bit is 1 are the Offset (13 bits in bytes
    #7 & #8) and the Identification (16 bits in bytes #5 
    & #6) fields ignored?  Can they be set to any value?

Q4: In byte #2 is the Type of Service Field ever used?
    Can any pattern be set here?

Q5: Options can follow byte #20.  An option has a two
    byte header, the 2nd byte is the length in bytes.
    This means that the data can be up to 254 bytes
    in length.  However the IHL has a maximum value
    of 15 (= 60 bytes).  Does this mean that the
    option data only has a real maximum of 38 bytes
    (40 minus the 2 option header bytes)?

Q6: Will routers honor datagrams that include an option 
    field that carry routing or neighbor greeting 
    information?  For example, if the payload a RIP,
    LSP or IS-IS data?  Or it is an ICMP message?

Q7: As a follow on to Q6.  Can the option be an option
    which has not yet been defined in an RFC?  E.g.
    an experimental or unregistered option number?
    Will a router honor it?  Will it allow RIP, LSP,
    IS-IS, ICMP, etc. to piggyback on it?

I appreciate any answers you may have.  Please ensure that
your response includes my email address ([email-masked])
since I am not a subscriber to your discussion group.

Thank you,

- Alex Alten
-- 

Alex Alten
P.O. Box 11406
Pleasanton, CA  94588
USA

[email-masked]
(510) 417-0159   Fax/Voice